<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../../favicon.png">
  <title>Built-in data tools | ToolDef documentation</title>
  <link rel="stylesheet" href="../../assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../../assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../introduction.html">Introduction</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-cur-page toc-item toc-item-parent expanded">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-7-0">Version 7.0</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-6-0-2024-12-20">Version 6.0 (2024-12-20)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../../documentation.html">ToolDef documentation</a> &gt; <a class="breadcrumb" href="../index.html">Language reference</a> &gt; <a class="breadcrumb" href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a> &gt; <span class="breadcrumb">Built-in data tools</span>
   </div>
   <h2 id="built-in-data-tools"><a class="anchor" href="#"></a>Built-in data tools</h2>
   <div class="paragraph">
    <p>This page describes the built-in data tools:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#abs-tool">abs</a></p></li>
     <li>
      <p><a href="#ceil-tool">ceil</a></p></li>
     <li>
      <p><a href="#contains-tool">contains</a></p></li>
     <li>
      <p><a href="#del-tool">del</a></p></li>
     <li>
      <p><a href="#delidx-tool">delidx</a></p></li>
     <li>
      <p><a href="#empty-tool">empty</a></p></li>
     <li>
      <p><a href="#endswith-tool">endswith</a></p></li>
     <li>
      <p><a href="#entries-tool">entries</a></p></li>
     <li>
      <p><a href="#enumerate-tool">enumerate</a></p></li>
     <li>
      <p><a href="#floor-tool">floor</a></p></li>
     <li>
      <p><a href="#fmt-tool">fmt</a></p></li>
     <li>
      <p><a href="#indexof-tool">indexof</a></p></li>
     <li>
      <p><a href="#join-tool">join</a></p></li>
     <li>
      <p><a href="#keys-tool">keys</a></p></li>
     <li>
      <p><a href="#lastindexof-tool">lastindexof</a></p></li>
     <li>
      <p><a href="#ln-tool">ln</a></p></li>
     <li>
      <p><a href="#log-tool">log</a></p></li>
     <li>
      <p><a href="#lower-tool">lower</a></p></li>
     <li>
      <p><a href="#ltrim-tool">ltrim</a></p></li>
     <li>
      <p><a href="#max-tool">max</a></p></li>
     <li>
      <p><a href="#min-tool">min</a></p></li>
     <li>
      <p><a href="#pow-tool">pow</a></p></li>
     <li>
      <p><a href="#range-tool">range</a></p></li>
     <li>
      <p><a href="#replace-tool">replace</a></p></li>
     <li>
      <p><a href="#reverse-tool">reverse</a></p></li>
     <li>
      <p><a href="#round-tool">round</a></p></li>
     <li>
      <p><a href="#rtrim-tool">rtrim</a></p></li>
     <li>
      <p><a href="#size-tool">size</a></p></li>
     <li>
      <p><a href="#sorted-tool">sorted</a></p></li>
     <li>
      <p><a href="#split-tool">split</a></p></li>
     <li>
      <p><a href="#sqrt-tool">sqrt</a></p></li>
     <li>
      <p><a href="#startswith-tool">startswith</a></p></li>
     <li>
      <p><a href="#str-tool">str</a></p></li>
     <li>
      <p><a href="#strdup-tool">strdup</a></p></li>
     <li>
      <p><a href="#subset-tool">subset</a></p></li>
     <li>
      <p><a href="#trim-tool">trim</a></p></li>
     <li>
      <p><a href="#upper-tool">upper</a></p></li>
     <li>
      <p><a href="#values-tool">values</a></p></li>
    </ul>
   </div>
   <div class="sect4">
    <h3 id="abs-tool"><a class="anchor" href="#abs-tool"></a>abs tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int    abs(int x)
tool long   abs(long x)
tool double abs(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the absolute value of an integer, long, or double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The integer, long, or double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The absolute value.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow (for integer and long numbers only).</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="ceil-tool"><a class="anchor" href="#ceil-tool"></a>ceil tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool long ceil(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given double number rounded to a whole long number, towards positive infinity.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The double number rounded to a whole long number, towards positive infinity.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="contains-tool"><a class="anchor" href="#contains-tool"></a>contains tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool contains(string whole, string part)
tool bool contains&lt;T&gt;(list T $list, T elem)
tool bool contains&lt;T&gt;(set T $set, T elem)
tool bool contains&lt;K,V&gt;(map(K:V) $map, K key)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether a given string is contained in another given string, a given value is contained in a given list, a given value is contained in a given set, or a given value is a key of a given map.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list or set.</p>
      </dd>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>whole</code>, <code>list</code>, <code>set</code>, <code>map</code>
      </dt>
      <dd>
       <p>The whole string, the list, the set, or the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>part</code>, <code>elem</code>, <code>key</code>
      </dt>
      <dd>
       <p>The part string (potentially contained in the whole string), or the value (potential element of the list or set, or potential key of the map).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the part string is contained in the whole string, if the value is contained in the list, if the value is contained in the set, or if the value is a key of the map, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="del-tool"><a class="anchor" href="#del-tool"></a>del tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list T   del&lt;T&gt;(list T $list, T elem)
tool set T    del&lt;T&gt;(set T $set, T elem)
tool map(K:V) del&lt;K,V&gt;(map(K:V) $map, K key)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given list with all occurrences of the given element removed from it, the given set with the given element removed from it, or the given map with the given entry with the given key removed from it. If the element or key does not exist, the list, set or map is returned unmodified.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list or set.</p>
      </dd>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>list</code>, <code>set</code>, <code>map</code>
      </dt>
      <dd>
       <p>The list, set, or map.</p>
      </dd>
      <dt class="hdlist1">
       <code>elem</code>, <code>key</code>
      </dt>
      <dd>
       <p>The element or key to remove. May be <code>null</code>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The list with all occurrences of the element removed from it, the set with the element removed from it, or the map with the entry with the given key removed from it.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="delidx-tool"><a class="anchor" href="#delidx-tool"></a>delidx tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list T delidx&lt;T&gt;(list T $list, int index)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Removes an element from a list, and returns the list without that element.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>list</code>
      </dt>
      <dd>
       <p>The list.</p>
      </dd>
      <dt class="hdlist1">
       <code>index</code>
      </dt>
      <dd>
       <p>The 0-based index into the list of the element to remove. Negative indices are allowed, and count from the right.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The list with the element removed from it.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the index is out of bounds for the list.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="empty-tool"><a class="anchor" href="#empty-tool"></a>empty tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool empty(string x)
tool bool empty&lt;T&gt;(list T x)
tool bool empty&lt;T&gt;(set T x)
tool bool empty&lt;K,V&gt;(map(K:V) x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether a given string, list, set, or map is empty (no characters, elements, or entries).</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list or set.</p>
      </dd>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The string, list, set, or map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the given string, list, set, or map is empty, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="endswith-tool"><a class="anchor" href="#endswith-tool"></a>endswith tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool endswith(string whole, string suffix)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first given string ends with the second given string. For an empty suffix, always returns <code>true</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>whole</code>
      </dt>
      <dd>
       <p>The first given string.</p>
      </dd>
      <dt class="hdlist1">
       <code>suffix</code>
      </dt>
      <dd>
       <p>The second given string.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first given string ends with the second given string, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="entries-tool"><a class="anchor" href="#entries-tool"></a>entries tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list tuple(K, V) entries&lt;K,V&gt;(map(K:V) $map)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns a list with 2-tuples of keys and values for all entries of the given map.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>map</code>
      </dt>
      <dd>
       <p>The map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The list with 2-tuples of keys and values for all entries of the given map.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="enumerate-tool"><a class="anchor" href="#enumerate-tool"></a>enumerate tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list tuple(int, T) enumerate&lt;T&gt;(list T $list)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns a list with 2-tuples of 0-based indices and elements for all elements of the given list.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>list</code>
      </dt>
      <dd>
       <p>The list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The list with 2-tuples of 0-based indices and elements for all elements of the given list.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="floor-tool"><a class="anchor" href="#floor-tool"></a>floor tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool long floor(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given double number rounded to a whole long number, towards negative infinity.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The double number rounded to a whole long number, towards negative infinity.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="fmt-tool"><a class="anchor" href="#fmt-tool"></a>fmt tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string fmt(string pattern, object?... args)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Formats a text based on a pattern and arguments.</p>
    </div>
    <div class="paragraph">
     <p>See also the <a href="#str-tool">str</a> tool, as <code>str(value)</code> is equal to <code>fmt("%s", value)</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>pattern</code>
      </dt>
      <dd>
       <p>The format pattern.</p>
      </dd>
      <dt class="hdlist1">
       <code>args</code>
      </dt>
      <dd>
       <p>The arguments.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The formatted text.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the format pattern is invalid.</p></li>
      <li>
       <p>If the format pattern and arguments don’t match.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="indexof-tool"><a class="anchor" href="#indexof-tool"></a>indexof tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int indexof(string whole, string part)
tool int indexof(string whole, string part, int offset)
tool int indexof&lt;T&gt;(list T $list, T elem)
tool int indexof&lt;T&gt;(list T $list, T elem, int offset)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the 0-based index of the first occurrence of the second given string or value, in the first given string or list. The tool looks for an occurrence from left to right of the first given string or elements of the first given list. If an offset is given, the tool only looks for an occurrence at or after that 0-based offset. If no offset is not given, the tool starts looking at the first (left most) character or list element.</p>
    </div>
    <div class="paragraph">
     <p>Returns <code>-1</code> if the second given string or value doesn’t occur in the first given string or list, at or after the 0-based offset if given, or at all if no offset is given. For an empty second string, always returns <code>0</code> if no offset is given. For an empty second string, if an offset is given, always returns the offset, unless there is no character at the given offset, in which <code>-1</code> is always returned.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>whole</code>, <code>list</code>
      </dt>
      <dd>
       <p>The first given string, or the list.</p>
      </dd>
      <dt class="hdlist1">
       <code>part</code>, <code>elem</code>
      </dt>
      <dd>
       <p>The second given string, or the value.</p>
      </dd>
      <dt class="hdlist1">
       <code>offset</code>
      </dt>
      <dd>
       <p>The optional 0-based offset.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The 0-based index of the first occurrence, at or after the given offset if given, or <code>-1</code>.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="join-tool"><a class="anchor" href="#join-tool"></a>join tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string join(string... texts)
tool string join(list string texts)
tool string join(list string texts, string separator)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given texts joined together. They can be joined without any separator, or using a given separator.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>texts</code>
      </dt>
      <dd>
       <p>The texts to join.</p>
      </dd>
      <dt class="hdlist1">
       <code>separator</code>
      </dt>
      <dd>
       <p>The optional separator text to use.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The joined texts.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="keys-tool"><a class="anchor" href="#keys-tool"></a>keys tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool set K keys&lt;K,V&gt;(map(K:V) $map)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns a set with the keys of the given map.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>map</code>
      </dt>
      <dd>
       <p>The map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The set with the keys of the map.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="lastindexof-tool"><a class="anchor" href="#lastindexof-tool"></a>lastindexof tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int lastindexof(string whole, string part)
tool int lastindexof(string whole, string part, int offset)
tool int lastindexof&lt;T&gt;(list T $list, T elem)
tool int lastindexof&lt;T&gt;(list T $list, T elem, int offset)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the 0-based index of the last occurrence of the second given string or value, in the first given string or list. The tool looks for an occurrence from left to right of the first given string or elements of the first given list. If an offset is given, the tool only looks for an occurrence at or before that 0-based offset. If no offset is not given, the tool starts looking at the first (left most) character or list element.</p>
    </div>
    <div class="paragraph">
     <p>Returns <code>-1</code> if the second given string or value doesn’t occur in the first given string or list, at or before the 0-based offset if given, or at all if no offset is given. For an empty second string, always returns the size of the first given string, if no offset is given. For an empty second string, if an offset is given, always returns the offset, unless there is no character at the given offset, in which <code>-1</code> is always returned.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>whole</code>, <code>list</code>
      </dt>
      <dd>
       <p>The first given string, or the list.</p>
      </dd>
      <dt class="hdlist1">
       <code>part</code>, <code>elem</code>
      </dt>
      <dd>
       <p>The second given string, or the value.</p>
      </dd>
      <dt class="hdlist1">
       <code>offset</code>
      </dt>
      <dd>
       <p>The optional 0-based offset.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The 0-based index of the last occurrence, at or before the given offset if given, or <code>-1</code>.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="ln-tool"><a class="anchor" href="#ln-tool"></a>ln tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool double ln(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the natural logarithm of a double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The natural logarithm of the double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the double number is not positive.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="log-tool"><a class="anchor" href="#log-tool"></a>log tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool double log(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the logarithm (base 10) of a double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The logarithm (base 10) of the double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the double number is not positive.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="lower-tool"><a class="anchor" href="#lower-tool"></a>lower tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string lower(string text)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given text, converted to lower case. Uses a US English locale.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The text.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The text, in lower case.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="ltrim-tool"><a class="anchor" href="#ltrim-tool"></a>ltrim tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string ltrim(string text)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given text with whitespace at the left/start of the text removed.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The text.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The text with whitespace at the left/start of the text removed.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="max-tool"><a class="anchor" href="#max-tool"></a>max tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int    max(int... x)
tool long   max(long... x)
tool double max(double... x)
tool int    max(list int x)
tool long   max(list long x)
tool double max(list double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the maximum of some integer, long, or double numbers. If no numbers are given, the minimum representable finite integer, long, or double value is returned.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The integer, long, or double numbers.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The maximum number.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="min-tool"><a class="anchor" href="#min-tool"></a>min tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int    min(int... x)
tool long   min(long... x)
tool double min(double... x)
tool int    min(list int x)
tool long   min(list long x)
tool double min(list double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the minimum of some integer, long, or double numbers. If no numbers are given, the maximum representable finite integer, long, or double value is returned.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The integer, long, or double numbers.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The minimum number.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="pow-tool"><a class="anchor" href="#pow-tool"></a>pow tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool double pow(double base, double exponent)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the exponentiation (power) of two double numbers.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>base</code>
      </dt>
      <dd>
       <p>The base double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>exponent</code>
      </dt>
      <dd>
       <p>The exponent double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The exponentiation result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in double overflow, or <code>NaN</code>.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="range-tool"><a class="anchor" href="#range-tool"></a>range tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list int range(int count)
tool list int range(int begin, int $end)
tool list int range&lt;T&gt;(list T $list)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns a list of numbers representing the range <code>[0..count-1]</code>, <code>[begin..end]</code>, or <code>[0..size(list)-1]</code>. That is, for <code>count</code> = <code>5</code> the list <code>[0, 1, 2, 3, 4]</code> is returned, for <code>begin</code> = <code>-3</code> and <code>end</code> = <code>2</code> the list <code>[-3, -2, -1, 0, 1, 2]</code> is returned, and for a <code>list</code> with <code>5</code> elements the list <code>[0, 1, 2, 3, 4]</code> is returned.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>count</code>
      </dt>
      <dd>
       <p>The number of elements in the resulting list. Negative counts are treated as zero.</p>
      </dd>
      <dt class="hdlist1">
       <code>begin</code>
      </dt>
      <dd>
       <p>The lower bound of the range.</p>
      </dd>
      <dt class="hdlist1">
       <code>end</code>
      </dt>
      <dd>
       <p>The upper bound of the range.</p>
      </dd>
      <dt class="hdlist1">
       <code>list</code>
      </dt>
      <dd>
       <p>The list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The range <code>[0..count-1]</code>, <code>[begin..end]</code>, or <code>[0..size(list)-1]</code>.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="replace-tool"><a class="anchor" href="#replace-tool"></a>replace tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string replace(string text, string oldtext, string newtext)
tool list T replace&lt;T&gt;(list T $list, T oldelem, T newelem)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the string or list with old sub strings or elements replaced by new text or elements. For strings, the replacement proceeds from the beginning of the string to the end. That is, replacing <code>"aa"</code> with <code>"b"</code> in the string <code>"aaa"</code> will result in <code>"ba"</code> rather than <code>"ab"</code>. For lists, the replacement is performed for all matching old elements.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>, <code>list</code>
      </dt>
      <dd>
       <p>The text (string) or list in which to replace text or elements.</p>
      </dd>
      <dt class="hdlist1">
       <code>oldtext</code>, <code>oldelem</code>
      </dt>
      <dd>
       <p>The text (sub string) or element to replace. For list elements, it may be <code>null</code>.</p>
      </dd>
      <dt class="hdlist1">
       <code>newtext</code>, <code>newelem</code>
      </dt>
      <dd>
       <p>The replacement text or element. For list elements, it may be <code>null</code>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The text or list with all replacements applied.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="reverse-tool"><a class="anchor" href="#reverse-tool"></a>reverse tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string reverse(string text)
tool list T reverse&lt;T&gt;(list T $list)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the reverse of the given string or list.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>, <code>list</code>
      </dt>
      <dd>
       <p>The string or list.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The reverse string or list.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="round-tool"><a class="anchor" href="#round-tool"></a>round tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool long round(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given double number rounded to the closest whole long number, with ties being rounded toward positive infinity.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The rounded number.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="rtrim-tool"><a class="anchor" href="#rtrim-tool"></a>rtrim tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string rtrim(string text)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given text with whitespace at the right/end of the text removed.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The text.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The text with whitespace at the right/end of the text removed.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="size-tool"><a class="anchor" href="#size-tool"></a>size tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int size(string x)
tool int size&lt;T&gt;(list T x)
tool int size&lt;T&gt;(set T x)
tool int size&lt;K,V&gt;(map(K:V) x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the size (number of characters, elements, or entries) of the given string, list, set, or map.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list or set.</p>
      </dd>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The string, list, set, or map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The size.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="sorted-tool"><a class="anchor" href="#sorted-tool"></a>sorted tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list T sorted&lt;T&gt;(list T $list)
tool list T sorted&lt;T&gt;(set T $set)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given list, or the given set as a list, with the elements sorted in ascending order.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list or set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>list</code>
      </dt>
      <dd>
       <p>The list.</p>
      </dd>
      <dt class="hdlist1">
       <code>set</code>
      </dt>
      <dd>
       <p>The set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The sorted list.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="split-tool"><a class="anchor" href="#split-tool"></a>split tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list string split(string text, string? separator = null, bool removeEmpty = true)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Splits the given text at all non-overlapping occurrences of the given separator.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The text to split.</p>
      </dd>
      <dt class="hdlist1">
       <code>separator</code>
      </dt>
      <dd>
       <p>The separator text. May be empty or <code>null</code> to split on whitespace.</p>
      </dd>
      <dt class="hdlist1">
       <code>removeEmpty</code>
      </dt>
      <dd>
       <p>Whether to remove empty parts (in case the text starts or ends with the separator, or in case the text contains consecutive separators), or not.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The parts of the original text resulting from splitting the original text at the separators.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="sqrt-tool"><a class="anchor" href="#sqrt-tool"></a>sqrt tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool double sqrt(double x)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the square root of a double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>x</code>
      </dt>
      <dd>
       <p>The double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The square root.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the double number is negative.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="startswith-tool"><a class="anchor" href="#startswith-tool"></a>startswith tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool startswith(string whole, string prefix)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first given string starts with the second given string. For an empty prefix, always returns <code>true</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>whole</code>
      </dt>
      <dd>
       <p>The first given string.</p>
      </dd>
      <dt class="hdlist1">
       <code>prefix</code>
      </dt>
      <dd>
       <p>The second given string.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first given string starts with the second given string, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="str-tool"><a class="anchor" href="#str-tool"></a>str tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string str(object? value)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Converts the given value into a textual representation, closely resembling the ToolDef syntax.</p>
    </div>
    <div class="paragraph">
     <p>Values of type <code>string</code> as returned as provided. Values of type <code>string</code> included in containers such as lists are escaped and surrounded by double quotes, as in the ToolDef syntax.</p>
    </div>
    <div class="paragraph">
     <p>See also the <a href="#fmt-tool">fmt</a> tool, as <code>str(value)</code> is equal to <code>fmt("%s", value)</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>value</code>
      </dt>
      <dd>
       <p>The value to convert to a textual representation.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The textual representation.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="strdup-tool"><a class="anchor" href="#strdup-tool"></a>strdup tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string strdup(string text, int count)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Duplicates a string a given number of times.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The string to duplicate.</p>
      </dd>
      <dt class="hdlist1">
       <code>count</code>
      </dt>
      <dd>
       <p>The number of times that the input string should occur in the output.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The concatenation of <code>count</code> times the <code>text</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the count is negative.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="subset-tool"><a class="anchor" href="#subset-tool"></a>subset tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool subset&lt;T&gt;(set T part, set T whole)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first given set is a subset (proper subset or equal) of the second given set.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the sets.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>part</code>
      </dt>
      <dd>
       <p>The first set.</p>
      </dd>
      <dt class="hdlist1">
       <code>whole</code>
      </dt>
      <dd>
       <p>The second set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first given set is a subset of the second given set, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="trim-tool"><a class="anchor" href="#trim-tool"></a>trim tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string trim(string text)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given text with whitespace at the left/start and right/end of the text removed.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The text.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The text with whitespace at the left/start and right/end of the text removed.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="upper-tool"><a class="anchor" href="#upper-tool"></a>upper tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool string upper(string text)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the given text, converted to upper case. Uses a US English locale.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>text</code>
      </dt>
      <dd>
       <p>The text.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The text, in upper case.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="values-tool"><a class="anchor" href="#values-tool"></a>values tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool set V values&lt;K,V&gt;(map(K:V) $map)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns a set with the values of the given map.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>map</code>
      </dt>
      <dd>
       <p>The map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The set with the values of the map.</p>
    </div>
   </div>
  </div>
  <script src="../../assets/highlight.min.js"></script>
  <script src="../../assets/languages/asciidoc.min.js"></script>
  <script src="../../assets/languages/bash.min.js"></script>
  <script src="../../assets/languages/bnf.min.js"></script>
  <script src="../../assets/languages/c.min.js"></script>
  <script src="../../assets/languages/chi.min.js"></script>
  <script src="../../assets/languages/cif.min.js"></script>
  <script src="../../assets/languages/console.min.js"></script>
  <script src="../../assets/languages/css.min.js"></script>
  <script src="../../assets/languages/dsm.min.js"></script>
  <script src="../../assets/languages/java.min.js"></script>
  <script src="../../assets/languages/javascript.min.js"></script>
  <script src="../../assets/languages/markdown.min.js"></script>
  <script src="../../assets/languages/mcrl2.min.js"></script>
  <script src="../../assets/languages/none.min.js"></script>
  <script src="../../assets/languages/plcst.min.js"></script>
  <script src="../../assets/languages/properties.min.js"></script>
  <script src="../../assets/languages/raildiagram.min.js"></script>
  <script src="../../assets/languages/setext.min.js"></script>
  <script src="../../assets/languages/shell.min.js"></script>
  <script src="../../assets/languages/tooldef.min.js"></script>
  <script src="../../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation</span> | <span>version v7.0-M1</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>